10 idr$ = 'dos3_Snaps_QC_120x80_'
11 odr$ = 'ram1_sz1_'
12 er = FMAKE_DIR(odr$)
13 :
14 REMark V0.02
15 REMark Extracts the masks from all the shapes in a directory that conform
16 REMark to the DF, DS, DE, etc pattern, and converts them into blobs and
17 REMark patterns. Can also be used on individual sprites:
18 :
19 REMark     PRINT SprSplit(indir$, outdir$, name$)
20 REMark For details see below.
21 :
22 IF JOBID THEN
23  cw = FOPEN("con")
24 ELSE
25  cw = 1
26 END IF
27 CLS#cw
28 :
29 DRO$ = 'DRO':                   REMark Shapes: Diamond, Rectangle, Oval
30 FSE$ = 'FSE':                   REMark Fills: Filled, Shaded, Empty
31 :
32 FOR i% = 1 TO 3
33  FOR j% = 1 TO 3
34   n$  = DRO$(i%) & FSE$(j%)
35   er = SprSplit(idr$, odr$, n$)
36   IF er < 0: PRINT#cw; er$, idr$ & n$ & '_spr', ERRM$(er): NEXT j%: EXIT j%
37  END FOR j%
38 END FOR i%
39 PRINT#cw; 'Done'
40 :
41 IF JOBID THEN
42  PAUSE#cw: QUIT
43 END IF
44 :
45 :
46 REMark + ------------------------------------------------------------------------ +
47 REMark |<                              Sprite Split                              >|
48 REMark + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
49 REMark |             Split a sprite into blob and pattern components              |
50 REMark |                                                                          |
51 REMark | Patterns may be described as colour, and blobs as mask.                  |
52 REMark | The sprites it can handle are limited to simple (ie not chained and no   |
53 REMark | option block), non-system, either solid or bit masked (ie no alpha).     |
54 REMark | Using BLOBW (or WBLOB) a blob can later be paired with a pattern to      |
55 REMark | form a sprite. The blob and pattern neednt be of the same mode!          |
56 REMark | The pattern neednt be a single colour, but its x-size must be a          |
57 REMark | multiple of 16 pixels.                                                   |
58 REMark |                                                                          |
59 REMark | Parameters: idr$ = input dir_,                                           |
60 REMark |             odr$ = out dir_ if given as "") then in dir is used,         |
61 REMark |             nm$  = sprite name sans extension                            |                                                                         |
62 REMark + ------------------------------------------------------------------------ +
63 REMark | V0.01, pjw, 2018 Dec 20                                                  |
64 REMark + ------------------------------------------------------------------------ +
65 :
66 DEFine FuNction SprSplit(idr$, odr$, nm$)
67 LOCal ch, spr, fl, blb, pat, alpha
68 LOCal sm%, cm%, fnm$, x$
69 er$ = ''
70 fnm$ = idr$ & nm$ & '_spr'
71 ch = FOP_IN(fnm$)
72 IF ch < 0: RETurn ch
73 fl = FLEN(#ch): CLOSE#ch
74 :
75 spr = ALCHP(fl)
76 LBYTES fnm$, spr
77 :
78 sm% = PEEK(spr)
79 cm% = PEEK(spr + 1)
80 SELect ON sm%
81  = 0: er$ = 'System': RETurn -19
82  = 1: REMark QL mode
83  = 2: REMark GD2
84    SELect ON cm%: = 16, 32, 33, 64: = REMAINDER : er$ = 'Wrong mode': RETurn -19
85  = REMAINDER : er$ = 'Not a sprite': RETurn -15
86 END SELect
87 :
88 ct% = PEEK(spr + 3)
89 IF ct% && 32: alpha = 1: else: alpha = 0: rem er$ = 'Alpha': RETurn -19
90 IF ct% &&  4: er$ = 'Options': RETurn -19
91 IF PEEK_L(spr + 20) <> 0: er$ = 'Chained': RETurn -19
92 :
93 pad = spr + PEEK_L(spr + 12) + 12
94 mad = spr + PEEK_L(spr + 16) + 16
95 :
96 IF pad < mad THEN
97  psz = mad - pad
98  msz = spr + fl - mad
99 ELSE
100  psz = spr + fl - pad
101  msz = pad - mad
102 END IF
103 :
104 IF LEN(odr$) = 0 THEN
105  onm$ = StripExt$(fnm$)
106 ELSE
107  onm$ = odr$ & nm$ & '_'
108 END IF
109 :
110 IF PEEK_L(spr + 12) > 0 THEN
111  SBYTES_O onm$ & 'pat', pad - 24, psz + 24
112  ch = FOPEN(onm$ & 'pat')
113  WPUT#ch; PEEK_W(spr)
114  BPUT#ch; PEEK(spr + 2)
115  BPUT#ch; PEEK(spr + 3) && 95: REMark Remove ref to comp mask & alpha
116  BPUT#ch; PEEK$(spr + 4, 8)
117  LPUT#ch; 12, 0, 0
118  CLOSE#ch
119 END IF
120 :
121 IF PEEK_L(spr + 16) > 0 THEN
122  if alpha: x$ = 'msk': else: x$ = 'blb'
123  SBYTES_O onm$ & x$, mad - 24, msz + 24
124  ch = FOPEN(onm$ & x$)
125  WPUT#ch; PEEK_W(spr)
126  BPUT#ch; PEEK(spr + 2)
127  BPUT#ch; PEEK(spr + 3) && 191: REMark Remove ref to comp pat
128  BPUT#ch; PEEK$(spr + 4, 8)
129  LPUT#ch; 0, 8, 0
130  CLOSE#ch
131 END IF
132 :
133 RECHP spr
134 RETurn 0
135 END DEFine SprSplit
136 :
137 :
138 DEFine FuNction StripExt$(fnm$)
139 LOCal i%
140 FOR i% = LEN(fnm$) TO 1 STEP -1
141  IF fnm$(i%) INSTR '_.': RETurn fnm$(1 TO i%)
142 END FOR i%
143 RETurn fnm$
144 END DEFine StripExt$
145 :
146 :
